﻿using System;
using System.Collections.Generic;
using System.Linq;

namespace MarkovGrams.Utilities
{
	public static class LinqExtensions
	{
		public static void ForEach<T>(this IEnumerable<T> enumerable, Action<T> action)
		{
			foreach (T item in enumerable)
			{
				action(item);
			}
		}

		public static T ShiftAt<T>(this List<T> list, int index)
		{
			T item = list[index];
			list.RemoveAt(index);
			return item;
		}
	}
}
